Index: LMDZ5/branches/testing/arch/arch-X64_ADA.fcm
===================================================================
--- LMDZ5/branches/testing/arch/arch-X64_ADA.fcm	(revision 2220)
+++ LMDZ5/branches/testing/arch/arch-X64_ADA.fcm	(revision 2258)
@@ -7,6 +7,7 @@
 %BASE_FFLAGS         -auto -mcmodel=large -integer-size 32 -real-size 64 -align all 
 %PROD_FFLAGS         -O2 -ip -fp-model strict -axAVX,SSE4.2
-%DEV_FFLAGS          -p -g -O1 -fpe0 -traceback
+%DEV_FFLAGS          -p -g -O0 -fpe0 -traceback
 %DEBUG_FFLAGS        -p -g -O0 -fpe-all=0 -traceback -ftrapuv -fp-stack-check -check all -debug
+#%DEBUG_FFLAGS        -p -g -O0 -fpe-all=0 -traceback -ftrapuv -fp-stack-check -debug
 %MPI_FFLAGS
 %OMP_FFLAGS          -openmp
Index: LMDZ5/branches/testing/libf/bibio/arth_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/bibio/arth_m.F90	(revision 2258)
+++ LMDZ5/branches/testing/libf/bibio/arth_m.F90	(revision 2258)
@@ -0,0 +1,88 @@
+MODULE arth_m
+
+  IMPLICIT NONE
+
+  INTEGER, PARAMETER, private:: NPAR_ARTH=16, NPAR2_ARTH=8
+
+  INTERFACE arth
+     ! Returns an arithmetic progression, given a first term "first", an
+     ! increment and a number of terms "n" (including "first").
+
+     MODULE PROCEDURE arth_r, arth_i
+     ! The difference between the procedures is the kind and type of
+     ! arguments first and increment and of function result.
+  END INTERFACE
+
+  private arth_r, arth_i
+
+CONTAINS
+
+  pure FUNCTION arth_r(first,increment,n)
+
+    REAL, INTENT(IN) :: first,increment
+    INTEGER, INTENT(IN) :: n
+    REAL arth_r(n)
+
+    ! Local:
+    INTEGER :: k,k2
+    REAL :: temp
+
+    !---------------------------------------
+
+    if (n > 0) arth_r(1)=first
+    if (n <= NPAR_ARTH) then
+       do k=2,n
+          arth_r(k)=arth_r(k-1)+increment
+       end do
+    else
+       do k=2,NPAR2_ARTH
+          arth_r(k)=arth_r(k-1)+increment
+       end do
+       temp=increment*NPAR2_ARTH
+       k=NPAR2_ARTH
+       do
+          if (k >= n) exit
+          k2=k+k
+          arth_r(k+1:min(k2,n)) = temp + arth_r(1:min(k,n-k))
+          temp=temp+temp
+          k=k2
+       end do
+    end if
+
+  END FUNCTION arth_r
+
+  !*************************************
+
+  pure FUNCTION arth_i(first,increment,n)
+
+    INTEGER, INTENT(IN) :: first,increment,n
+    INTEGER arth_i(n)
+
+    ! Local:
+    INTEGER :: k,k2,temp
+
+    !---------------------------------------
+
+    if (n > 0) arth_i(1)=first
+    if (n <= NPAR_ARTH) then
+       do k=2,n
+          arth_i(k)=arth_i(k-1)+increment
+       end do
+    else
+       do k=2,NPAR2_ARTH
+          arth_i(k)=arth_i(k-1)+increment
+       end do
+       temp=increment*NPAR2_ARTH
+       k=NPAR2_ARTH
+       do
+          if (k >= n) exit
+          k2=k+k
+          arth_i(k+1:min(k2,n))=temp+arth_i(1:min(k,n-k))
+          temp=temp+temp
+          k=k2
+       end do
+    end if
+
+  END FUNCTION arth_i
+
+END MODULE arth_m
Index: LMDZ5/branches/testing/libf/bibio/nrtype.F90
===================================================================
--- LMDZ5/branches/testing/libf/bibio/nrtype.F90	(revision 2258)
+++ LMDZ5/branches/testing/libf/bibio/nrtype.F90	(revision 2258)
@@ -0,0 +1,22 @@
+MODULE nrtype
+
+  implicit none
+
+  integer, parameter:: k8 = selected_real_kind(13)
+
+  ! Frequently used mathematical constants (with precision to spare):
+
+  REAL, PARAMETER :: PI=3.141592653589793238462643383279502884197
+  REAL, PARAMETER :: PIO2=1.57079632679489661923132169163975144209858
+  REAL, PARAMETER :: TWOPI=6.283185307179586476925286766559005768394
+  REAL, PARAMETER :: SQRT2=1.41421356237309504880168872420969807856967
+  REAL, PARAMETER :: EULER=0.5772156649015328606065120900824024310422
+
+  REAL(K8), PARAMETER:: &
+       PI_D = 3.141592653589793238462643383279502884197_k8
+  REAL(K8), PARAMETER:: &
+       PIO2_D=1.57079632679489661923132169163975144209858_k8
+  REAL(K8), PARAMETER:: &
+       TWOPI_D=6.283185307179586476925286766559005768394_k8
+
+END MODULE nrtype
Index: LMDZ5/branches/testing/libf/dyn3d/calfis.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/calfis.F	(revision 2220)
+++ LMDZ5/branches/testing/libf/dyn3d/calfis.F	(revision 2258)
@@ -21,5 +21,4 @@
      $                  pdq,
      $                  flxw,
-     $                  clesphy0,
      $                  pdufi,
      $                  pdvfi,
@@ -131,7 +130,4 @@
       REAL,INTENT(OUT) :: pdpsfi(iip1,jjp1) ! tendency on surface pressure (Pa/s)
 
-      INTEGER,PARAMETER :: longcles = 20
-      REAL,INTENT(IN) :: clesphy0( longcles ) ! unused
-
 
 c    Local variables :
@@ -465,5 +461,4 @@
      .             zphis,
      .             presnivs,
-     .             clesphy0,
      .             zufi,
      .             zvfi,
Index: LMDZ5/branches/testing/libf/dyn3d/ce0l.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/ce0l.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/dyn3d/ce0l.F90	(revision 2258)
@@ -41,11 +41,9 @@
 #include "temps.h"
 #include "logic.h"
-  INTEGER, PARAMETER            :: longcles=20
-  REAL,    DIMENSION(longcles)  :: clesphy0
   REAL,    DIMENSION(iip1,jjp1) :: masque
   CHARACTER(LEN=15)             :: calnd
   REAL,    DIMENSION(iip1,jjp1) :: phis ! geopotentiel au sol
 !-------------------------------------------------------------------------------
-  CALL conf_gcm( 99, .TRUE. , clesphy0 )
+  CALL conf_gcm( 99, .TRUE. )
 
   CALL Init_Phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
Index: LMDZ5/branches/testing/libf/dyn3d/conf_gcm.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/conf_gcm.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/dyn3d/conf_gcm.F90	(revision 2258)
@@ -2,5 +2,5 @@
 ! $Id$
 
-SUBROUTINE conf_gcm( tapedef, etatinit, clesphy0 )
+SUBROUTINE conf_gcm( tapedef, etatinit )
 
   USE control_mod
@@ -23,12 +23,7 @@
   !     etatinit  :     = TRUE   , on ne  compare pas les valeurs des para- 
   !     -metres  du zoom  avec  celles lues sur le fichier start .
-  !      clesphy0 :  sortie  .
-
-  LOGICAL etatinit
-  INTEGER tapedef
-
-  INTEGER        longcles
-  PARAMETER(     longcles = 20 )
-  REAL clesphy0( longcles )
+
+  LOGICAL,INTENT(IN) :: etatinit
+  INTEGER,INTENT(IN) :: tapedef
 
   !   Declarations :
@@ -41,7 +36,4 @@
   include "temps.h"
   include "comconst.h"
-
-  ! FH 2008/05/09 On elimine toutes les clefs physiques dans la dynamique
-  ! include "clesphys.h"
   include "iniprint.h"
 
@@ -381,8 +373,4 @@
   ip_ebil_dyn = 0
   CALL getin('ip_ebil_dyn',ip_ebil_dyn)
-
-  DO i = 1, longcles
-     clesphy0(i) = 0.
-  ENDDO
 
   !cc  ....   P. Le Van , ajout  le 7/03/95 .pour le zoom ...
@@ -734,6 +722,7 @@
      !Config  Help = extension en longitude  de la zone du zoom  
      !Config         ( fraction de la zone totale)
-     dzoomx = 0.0
+     dzoomx = 0.2
      CALL getin('dzoomx',dzoomx)
+     call assert(dzoomx < 1, "conf_gcm: dzoomx must be < 1")
 
      !Config  Key  = dzoomy
@@ -742,6 +731,7 @@
      !Config  Help = extension en latitude de la zone  du zoom  
      !Config         ( fraction de la zone totale)
-     dzoomy = 0.0
+     dzoomy = 0.2
      CALL getin('dzoomy',dzoomy)
+     call assert(dzoomy< 1, "conf_gcm: dzoomy must be < 1")
 
      !Config  Key  = taux
Index: LMDZ5/branches/testing/libf/dyn3d/gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/gcm.F	(revision 2220)
+++ LMDZ5/branches/testing/libf/dyn3d/gcm.F	(revision 2258)
@@ -26,4 +26,5 @@
 ! Only INCA needs these informations (from the Earth's physics)
       USE indice_sol_mod
+      USE mod_phys_lmdz_para, ONLY : klon_mpi_para_nb
 #endif
 
@@ -33,7 +34,6 @@
 ! dynamique -> physique pour l'initialisation
 #ifdef CPP_PHYS
-      USE dimphy
-      USE comgeomphy
-      USE mod_phys_lmdz_para, ONLY : klon_mpi_para_nb
+!      USE dimphy
+!      USE comgeomphy
 #endif
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -90,10 +90,4 @@
 !#include "indicesol.h"
 #endif
-      INTEGER         longcles
-      PARAMETER     ( longcles = 20 )
-      REAL  clesphy0( longcles )
-      SAVE  clesphy0
-
-
 
       REAL zdtvr
@@ -125,6 +119,6 @@
       LOGICAL first
 
-      LOGICAL call_iniphys
-      data call_iniphys/.true./
+!      LOGICAL call_iniphys
+!      data call_iniphys/.true./
 
 c+jld variables test conservation energie
@@ -147,15 +141,4 @@
       REAL :: heure
 
-
-c-----------------------------------------------------------------------
-c    variables pour l'initialisation de la physique :
-c    ------------------------------------------------
-      INTEGER ngridmx
-      PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
-      REAL zcufi(ngridmx),zcvfi(ngridmx)
-      REAL latfi(ngridmx),lonfi(ngridmx)
-      REAL airefi(ngridmx)
-      SAVE latfi, lonfi, airefi
-
 c-----------------------------------------------------------------------
 c   Initialisations:
@@ -175,12 +158,7 @@
 c  ---------------------------------------
 c
-! Ehouarn: dump possibility of using defrun
-!#ifdef CPP_IOIPSL
-      CALL conf_gcm( 99, .TRUE. , clesphy0 )
+      CALL conf_gcm( 99, .TRUE.)
       if (mod(iphysiq, iperiod) /= 0) call abort_gcm("conf_gcm",
      s "iphysiq must be a multiple of iperiod", 1)
-!#else
-!      CALL defrun( 99, .TRUE. , clesphy0 )
-!#endif
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -199,5 +177,5 @@
 #ifdef CPP_PHYS
       CALL Init_Phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
-      call InitComgeomphy
+!      call InitComgeomphy ! now done in iniphysiq
 #endif
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -215,5 +193,5 @@
         call ioconf_calendar('noleap')
         write(lunout,*)'CALENDRIER CHOISI: Terrestre a 365 jours/an'
-      else if (calend == 'earth_366d') then
+      else if (calend == 'gregorian') then
         call ioconf_calendar('gregorian')
         write(lunout,*)'CALENDRIER CHOISI: Terrestre bissextile'
@@ -316,9 +294,9 @@
 
 C
-C on remet le calendrier à zero si demande
+C on remet le calendrier \`a zero si demande
 c
       IF (start_time /= starttime) then
         WRITE(lunout,*)' GCM: Attention l''heure de depart lue dans le'
-     &,' fichier restart ne correspond pas à celle lue dans le run.def'
+     &,' fichier restart ne correspond pas a celle lue dans le run.def'
         IF (raz_date == 1) then
           WRITE(lunout,*)'Je prends l''heure lue dans run.def'
@@ -428,32 +406,12 @@
 c   -------------------------------
 
-      IF (call_iniphys.and.(iflag_phys==1.or.iflag_phys>=100)) THEN
-         latfi(1)=rlatu(1)
-         lonfi(1)=0.
-         zcufi(1) = cu(1)
-         zcvfi(1) = cv(1)
-         DO j=2,jjm
-            DO i=1,iim
-               latfi((j-2)*iim+1+i)= rlatu(j)
-               lonfi((j-2)*iim+1+i)= rlonv(i)
-               zcufi((j-2)*iim+1+i) = cu((j-1)*iip1+i)
-               zcvfi((j-2)*iim+1+i) = cv((j-1)*iip1+i)
-            ENDDO
-         ENDDO
-         latfi(ngridmx)= rlatu(jjp1)
-         lonfi(ngridmx)= 0.
-         zcufi(ngridmx) = cu(ip1jm+1)
-         zcvfi(ngridmx) = cv(ip1jm-iim)
-         CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,aire,airefi)
-         WRITE(lunout,*)
-     .       'GCM: WARNING!!! vitesse verticale nulle dans la physique'
+      IF ((iflag_phys==1).or.(iflag_phys>=100)) THEN
 ! Physics:
 #ifdef CPP_PHYS
-         CALL iniphysiq(ngridmx,llm,daysec,day_ini,dtphys/nsplit_phys,
-     &                latfi,lonfi,airefi,zcufi,zcvfi,rad,g,r,cpp,
+         CALL iniphysiq(iim,jjm,llm,daysec,day_ini,dtphys/nsplit_phys,
+     &                rlatu,rlonv,aire,cu,cv,rad,g,r,cpp,
      &                iflag_phys)
 #endif
-         call_iniphys=.false.
-      ENDIF ! of IF (call_iniphys.and.(iflag_phys.eq.1))
+      ENDIF ! of IF ((iflag_phys==1).or.(iflag_phys>=100))
 
 c  numero de stockage pour les fichiers de redemarrage:
@@ -530,6 +488,5 @@
 
 
-      CALL leapfrog(ucov,vcov,teta,ps,masse,phis,q,clesphy0,
-     .              time_0)
+      CALL leapfrog(ucov,vcov,teta,ps,masse,phis,q,time_0)
 
       END
Index: LMDZ5/branches/testing/libf/dyn3d/leapfrog.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/leapfrog.F	(revision 2220)
+++ LMDZ5/branches/testing/libf/dyn3d/leapfrog.F	(revision 2258)
@@ -4,6 +4,5 @@
 c
 c
-      SUBROUTINE leapfrog(ucov,vcov,teta,ps,masse,phis,q,clesphy0,
-     &                    time_0)
+      SUBROUTINE leapfrog(ucov,vcov,teta,ps,masse,phis,q,time_0)
 
 
@@ -70,9 +69,4 @@
 #include "academic.h"
 
-! FH 2008/05/09 On elimine toutes les clefs physiques dans la dynamique
-! #include "clesphys.h"
-
-      INTEGER,PARAMETER :: longcles = 20
-      REAL,INTENT(IN) :: clesphy0( longcles ) ! not used
       REAL,INTENT(IN) :: time_0 ! not used
 
@@ -446,6 +440,5 @@
      $               ucov,vcov,teta,q,masse,ps,p,pk,phis,phi ,
      $               du,dv,dteta,dq,
-     $               flxw,
-     $               clesphy0, dufi,dvfi,dtetafi,dqfi,dpfi  )
+     $               flxw,dufi,dvfi,dtetafi,dqfi,dpfi  )
 
 c      ajout des tendances physiques:
Index: LMDZ5/branches/testing/libf/dyn3d_common/coefpoly_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d_common/coefpoly_m.F90	(revision 2258)
+++ LMDZ5/branches/testing/libf/dyn3d_common/coefpoly_m.F90	(revision 2258)
@@ -0,0 +1,52 @@
+module coefpoly_m
+
+  IMPLICIT NONE
+
+contains
+
+  SUBROUTINE coefpoly(xf1, xf2, xprim1, xprim2, xtild1, xtild2, a0, a1, a2, a3)
+
+    ! From LMDZ4/libf/dyn3d/coefpoly.F, version 1.1.1.1 2004/05/19 12:53:05
+
+    ! Author: P. Le Van
+
+    ! Calcul des coefficients a0, a1, a2, a3 du polynôme de degré 3 qui
+    ! satisfait aux 4 équations suivantes :
+
+    ! a0 + a1 * xtild1 + a2 * xtild1**2 + a3 * xtild1**3 = Xf1
+    ! a0 + a1 * xtild2 + a2 * xtild2**2 + a3 * xtild2**3 = Xf2
+    ! a1 + 2. * a2 * xtild1 + 3. * a3 * xtild1**2 = Xprim1
+    ! a1 + 2. * a2 * xtild2 + 3. * a3 * xtild2**2 = Xprim2
+
+    ! (passe par les points (Xf(it), xtild(it)) et (Xf(it + 1),
+    ! xtild(it + 1))
+
+    ! On en revient à resoudre un système de 4 équations à 4 inconnues
+    ! a0, a1, a2, a3.
+
+    use nrtype, only: k8
+
+    REAL(K8), intent(in):: xf1, xf2, xprim1, xprim2, xtild1, xtild2
+    REAL(K8), intent(out):: a0, a1, a2, a3
+
+    ! Local:
+    REAL(K8) xtil1car, xtil2car, derr, x1x2car
+
+    !------------------------------------------------------------
+
+    xtil1car = xtild1 * xtild1
+    xtil2car = xtild2 * xtild2
+
+    derr = 2. * (xf2-xf1)/(xtild1-xtild2)
+
+    x1x2car = (xtild1-xtild2) * (xtild1-xtild2)
+
+    a3 = (derr+xprim1+xprim2)/x1x2car
+    a2 = (xprim1-xprim2+3. * a3 * (xtil2car-xtil1car))/(2. * (xtild1-xtild2))
+
+    a1 = xprim1 - 3. * a3 * xtil1car - 2. * a2 * xtild1
+    a0 = xf1 - a3 * xtild1 * xtil1car - a2 * xtil1car - a1 * xtild1
+
+  END SUBROUTINE coefpoly
+
+end module coefpoly_m
Index: LMDZ5/branches/testing/libf/dyn3d_common/fxhyp_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d_common/fxhyp_m.F90	(revision 2258)
+++ LMDZ5/branches/testing/libf/dyn3d_common/fxhyp_m.F90	(revision 2258)
@@ -0,0 +1,250 @@
+module fxhyp_m
+
+  IMPLICIT NONE
+
+contains
+
+  SUBROUTINE fxhyp(xprimm025, rlonv, xprimv, rlonu, xprimu, xprimp025)
+
+    ! From LMDZ4/libf/dyn3d/fxhyp.F, version 1.2, 2005/06/03 09:11:32
+    ! Author: P. Le Van, from formulas by R. Sadourny
+
+    ! Calcule les longitudes et dérivées dans la grille du GCM pour
+    ! une fonction f(x) à dérivée tangente hyperbolique.
+
+    ! Il vaut mieux avoir : grossismx \times dzoom < pi
+
+    ! Le premier point scalaire pour une grille regulière (grossismx =
+    ! 1., taux=0., clon=0.) est à - 180 degrés.
+
+    use arth_m, only: arth
+    use invert_zoom_x_m, only: invert_zoom_x, nmax
+    use nrtype, only: pi, pi_d, twopi, twopi_d, k8
+    use principal_cshift_m, only: principal_cshift
+
+    include "dimensions.h"
+    ! for iim
+
+    include "serre.h"
+    ! for clon, grossismx, dzoomx, taux
+
+    REAL, intent(out):: xprimm025(:), rlonv(:), xprimv(:) ! (iim + 1)
+    real, intent(out):: rlonu(:), xprimu(:), xprimp025(:) ! (iim + 1)
+
+    ! Local:
+    real rlonm025(iim + 1), rlonp025(iim + 1)
+    REAL dzoom, step
+    real d_rlonv(iim)
+    REAL(K8) xtild(0:2 * nmax)
+    REAL(K8) fhyp(nmax:2 * nmax), ffdx, beta, Xprimt(0:2 * nmax)
+    REAL(K8) Xf(0:2 * nmax), xxpr(2 * nmax)
+    REAL(K8) fa, fb
+    INTEGER i, is2
+    REAL(K8) xmoy, fxm
+
+    !----------------------------------------------------------------------
+
+    print *, "Call sequence information: fxhyp"
+
+    test_iim: if (iim==1) then
+       rlonv(1)=0.
+       rlonu(1)=pi
+       rlonv(2)=rlonv(1)+twopi
+       rlonu(2)=rlonu(1)+twopi
+
+       xprimm025(:)=1.
+       xprimv(:)=1.
+       xprimu(:)=1.
+       xprimp025(:)=1.
+    else test_iim
+       test_grossismx: if (grossismx == 1.) then
+          step = twopi / iim
+
+          xprimm025(:iim) = step
+          xprimp025(:iim) = step
+          xprimv(:iim) = step
+          xprimu(:iim) = step
+
+          rlonv(:iim) = arth(- pi + clon / 180. * pi, step, iim)
+          rlonm025(:iim) = rlonv(:iim) - 0.25 * step
+          rlonp025(:iim) = rlonv(:iim) + 0.25 * step
+          rlonu(:iim) = rlonv(:iim) + 0.5 * step
+       else test_grossismx
+          dzoom = dzoomx * twopi_d
+          xtild = arth(- pi_d, pi_d / nmax, 2 * nmax + 1)
+
+          ! Compute fhyp:
+          DO i = nmax, 2 * nmax
+             fa = taux * (dzoom / 2. - xtild(i))
+             fb = xtild(i) * (pi_d - xtild(i))
+
+             IF (200. * fb < - fa) THEN
+                fhyp(i) = - 1.
+             ELSE IF (200. * fb < fa) THEN
+                fhyp(i) = 1.
+             ELSE
+                IF (ABS(fa) < 1e-13 .AND. ABS(fb) < 1e-13) THEN
+                   IF (200. * fb + fa < 1e-10) THEN
+                      fhyp(i) = - 1.
+                   ELSE IF (200. * fb - fa < 1e-10) THEN
+                      fhyp(i) = 1.
+                   END IF
+                ELSE
+                   fhyp(i) = TANH(fa / fb)
+                END IF
+             END IF
+
+             IF (xtild(i) == 0.) fhyp(i) = 1.
+             IF (xtild(i) == pi_d) fhyp(i) = -1.
+          END DO
+
+          ! Calcul de beta 
+
+          ffdx = 0.
+
+          DO i = nmax + 1, 2 * nmax
+             xmoy = 0.5 * (xtild(i-1) + xtild(i))
+             fa = taux * (dzoom / 2. - xmoy)
+             fb = xmoy * (pi_d - xmoy)
+
+             IF (200. * fb < - fa) THEN
+                fxm = - 1.
+             ELSE IF (200. * fb < fa) THEN
+                fxm = 1.
+             ELSE
+                IF (ABS(fa) < 1e-13 .AND. ABS(fb) < 1e-13) THEN
+                   IF (200. * fb + fa < 1e-10) THEN
+                      fxm = - 1.
+                   ELSE IF (200. * fb - fa < 1e-10) THEN
+                      fxm = 1.
+                   END IF
+                ELSE
+                   fxm = TANH(fa / fb)
+                END IF
+             END IF
+
+             IF (xmoy == 0.) fxm = 1.
+             IF (xmoy == pi_d) fxm = -1.
+
+             ffdx = ffdx + fxm * (xtild(i) - xtild(i-1))
+          END DO
+
+          print *, "ffdx = ", ffdx
+          beta = (grossismx * ffdx - pi_d) / (ffdx - pi_d)
+          print *, "beta = ", beta
+
+          IF (2. * beta - grossismx <= 0.) THEN
+             print *, 'Bad choice of grossismx, taux, dzoomx.'
+             print *, 'Decrease dzoomx or grossismx.'
+             STOP 1
+          END IF
+
+          ! calcul de Xprimt 
+          Xprimt(nmax:2 * nmax) = beta + (grossismx - beta) * fhyp
+          xprimt(:nmax - 1) = xprimt(2 * nmax:nmax + 1:- 1)
+
+          ! Calcul de Xf
+
+          DO i = nmax + 1, 2 * nmax
+             xmoy = 0.5 * (xtild(i-1) + xtild(i))
+             fa = taux * (dzoom / 2. - xmoy)
+             fb = xmoy * (pi_d - xmoy)
+
+             IF (200. * fb < - fa) THEN
+                fxm = - 1.
+             ELSE IF (200. * fb < fa) THEN
+                fxm = 1.
+             ELSE
+                fxm = TANH(fa / fb)
+             END IF
+
+             IF (xmoy == 0.) fxm = 1.
+             IF (xmoy == pi_d) fxm = -1.
+             xxpr(i) = beta + (grossismx - beta) * fxm
+          END DO
+
+          xxpr(:nmax) = xxpr(2 * nmax:nmax + 1:- 1)
+
+          Xf(0) = - pi_d
+
+          DO i=1, 2 * nmax - 1
+             Xf(i) = Xf(i-1) + xxpr(i) * (xtild(i) - xtild(i-1))
+          END DO
+
+          Xf(2 * nmax) = pi_d
+
+          call invert_zoom_x(xf, xtild, Xprimt, rlonm025(:iim), &
+               xprimm025(:iim), xuv = - 0.25_k8)
+          call invert_zoom_x(xf, xtild, Xprimt, rlonv(:iim), xprimv(:iim), &
+               xuv = 0._k8)
+          call invert_zoom_x(xf, xtild, Xprimt, rlonu(:iim), xprimu(:iim), &
+               xuv = 0.5_k8)
+          call invert_zoom_x(xf, xtild, Xprimt, rlonp025(:iim), &
+               xprimp025(:iim), xuv = 0.25_k8)
+       end if test_grossismx
+
+       is2 = 0
+
+       IF (MINval(rlonm025(:iim)) < - pi - 0.1 &
+            .or. MAXval(rlonm025(:iim)) > pi + 0.1) THEN
+          IF (clon <= 0.) THEN
+             is2 = 1
+
+             do while (rlonm025(is2) < - pi .and. is2 < iim)
+                is2 = is2 + 1
+             end do
+
+             if (rlonm025(is2) < - pi) then
+                print *, 'Rlonm025 plus petit que - pi !'
+                STOP 1
+             end if
+          ELSE
+             is2 = iim
+
+             do while (rlonm025(is2) > pi .and. is2 > 1)
+                is2 = is2 - 1
+             end do
+
+             if (rlonm025(is2) > pi) then
+                print *, 'Rlonm025 plus grand que pi !'
+                STOP 1
+             end if
+          END IF
+       END IF
+
+       call principal_cshift(is2, rlonm025, xprimm025)
+       call principal_cshift(is2, rlonv, xprimv)
+       call principal_cshift(is2, rlonu, xprimu)
+       call principal_cshift(is2, rlonp025, xprimp025)
+
+       forall (i = 1: iim) d_rlonv(i) = rlonv(i + 1) - rlonv(i)
+       print *, "Minimum longitude step:", MINval(d_rlonv) * 180. / pi, &
+            "degrees"
+       print *, "Maximum longitude step:", MAXval(d_rlonv) * 180. / pi, &
+            "degrees"
+
+       ! Check that rlonm025 <= rlonv <= rlonp025 <= rlonu:
+       DO i = 1, iim + 1
+          IF (rlonp025(i) < rlonv(i)) THEN
+             print *, 'rlonp025(', i, ') = ', rlonp025(i)
+             print *, "< rlonv(", i, ") = ", rlonv(i)
+             STOP 1
+          END IF
+
+          IF (rlonv(i) < rlonm025(i)) THEN 
+             print *, 'rlonv(', i, ') = ', rlonv(i)
+             print *, "< rlonm025(", i, ") = ", rlonm025(i)
+             STOP 1
+          END IF
+
+          IF (rlonp025(i) > rlonu(i)) THEN
+             print *, 'rlonp025(', i, ') = ', rlonp025(i)
+             print *, "> rlonu(", i, ") = ", rlonu(i)
+             STOP 1
+          END IF
+       END DO
+    end if test_iim
+
+  END SUBROUTINE fxhyp
+
+end module fxhyp_m
